function [f,fx,fy] = spline_interpolate(warp,P,options);
% warp = spline_fit(P1,P2,options);
% warp = spline_fit(P1,P2,A,options);
  
  
  if nargin < 3;
    disp('wrong number of input arguments');
  else
    %keyboard;
    if not(strcmp(warp.type,options.type));
      disp('data and option warp types do not match');
    else;

      [N1,N2]=size(P);
      switch options.type
       case 'csp';
	f=csp_interp(warp.P1,P,warp.coeff);
	
       case 'cspd';
	value=cspd_interp(warp.P1,P,warp.coeff);
	f=value(1:N1,:);
	if nargout ==2;
	  fx=value(N1+1:end,:);
	end;
	
       case 'tps';
	f=tps_interp(warp.P1,P,warp.coeff);
       
       case 'tpsd';
	value=tpsd_interp(warp.P1,P,warp.coeff);
	f=value(1:N1,:);
	if nargout == 3;
	  fx=value(N1+1:2*N1,:);
	  fy=value(2*N1+1:end,:);
	end
	
       otherwise;
	disp('unrecognized warp type');
      end
    end
  end
  